/*!
 * Vux v0.1.3 (https://vux.li)
 * Licensed under the MIT license
 */
module.exports = function(modules) {
    var installedModules = {};
    function __webpack_require__(moduleId) {
        if (installedModules[moduleId]) return installedModules[moduleId].exports;
        var module = installedModules[moduleId] = {
            exports: {},
            id: moduleId,
            loaded: false
        };
        modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
        module.loaded = true;
        return module.exports;
    }
    __webpack_require__.m = modules;
    __webpack_require__.c = installedModules;
    __webpack_require__.p = "";
    return __webpack_require__(0);
}([ function(module, exports, __webpack_require__) {
    module.exports = __webpack_require__(4);
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    var _multiItems = __webpack_require__(2);
    exports.default = {
        mixins: [ _multiItems.childMixin ],
        computed: {
            classes: function classes() {
                return {
                    "vux-button-group-current": this.index === this.$parent.index,
                    "no-border-right": this.shouldRemoveBorder
                };
            },
            style: function style() {
                if (this.$parent.height) {
                    return {
                        height: this.$parent.height + "px",
                        lineHeight: this.$parent.height + "px"
                    };
                }
            }
        },
        data: function data() {
            return {
                shouldRemoveBorder: false
            };
        }
    };
}, function(module, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    var parentMixin = {
        ready: function ready() {
            this.updateIndex();
        },
        methods: {
            updateIndex: function updateIndex() {
                if (!this.$children) return;
                this.number = this.$children.length;
                var children = this.$children;
                for (var i = 0; i < children.length; i++) {
                    children[i].index = i;
                    if (children[i].selected) {
                        this.index = i;
                    }
                }
            }
        },
        props: {
            index: {
                type: Number,
                default: -1
            }
        },
        watch: {
            index: function index(val, oldVal) {
                oldVal > -1 && this.$children[oldVal] && (this.$children[oldVal].selected = false);
                val > -1 && (this.$children[val].selected = true);
            }
        },
        data: function data() {
            return {
                number: this.$children.length
            };
        }
    };
    var childMixin = {
        props: {
            selected: {
                type: Boolean,
                default: false
            }
        },
        ready: function ready() {
            this.$parent.updateIndex();
        },
        beforeDestroy: function beforeDestroy() {
            var $parent = this.$parent;
            this.$nextTick(function() {
                $parent.updateIndex();
            });
        },
        methods: {
            onItemClick: function onItemClick() {
                if (typeof this.disabled === "undefined" || this.disabled === false) {
                    this.selected = true;
                    this.$parent.index = this.index;
                    this.$emit("on-item-click");
                }
            }
        },
        watch: {
            selected: function selected(val) {
                if (val) {
                    this.$parent.index = this.index;
                } else {
                    this.$parent.index = -1;
                }
            }
        },
        data: function data() {
            return {
                index: -1
            };
        }
    };
    exports.parentMixin = parentMixin;
    exports.childMixin = childMixin;
}, function(module, exports) {
    module.exports = " <a class=vux-button-tab-item :class=classes href=javascript: :style=style @click=onItemClick> <slot></slot> </a> ";
}, function(module, exports, __webpack_require__) {
    var __vue_script__, __vue_template__;
    var __vue_styles__ = {};
    __vue_script__ = __webpack_require__(1);
    __vue_template__ = __webpack_require__(3);
    module.exports = __vue_script__ || {};
    if (module.exports.__esModule) module.exports = module.exports.default;
    var __vue_options__ = typeof module.exports === "function" ? module.exports.options || (module.exports.options = {}) : module.exports;
    if (__vue_template__) {
        __vue_options__.template = __vue_template__;
    }
    if (!__vue_options__.computed) __vue_options__.computed = {};
    Object.keys(__vue_styles__).forEach(function(key) {
        var module = __vue_styles__[key];
        __vue_options__.computed[key] = function() {
            return module;
        };
    });
} ]);