/*!
 * Vux v0.1.3 (https://vux.li)
 * Licensed under the MIT license
 */
module.exports = function(modules) {
    var installedModules = {};
    function __webpack_require__(moduleId) {
        if (installedModules[moduleId]) return installedModules[moduleId].exports;
        var module = installedModules[moduleId] = {
            exports: {},
            id: moduleId,
            loaded: false
        };
        modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
        module.loaded = true;
        return module.exports;
    }
    __webpack_require__.m = modules;
    __webpack_require__.c = installedModules;
    __webpack_require__.p = "";
    return __webpack_require__(0);
}([ function(module, exports, __webpack_require__) {
    module.exports = __webpack_require__(5);
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    var _clickOutside = __webpack_require__(2);
    var _clickOutside2 = _interopRequireDefault(_clickOutside);
    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }
    exports.default = {
        ready: function ready() {
            var _this = this;
            var triger = this.$els.trigger.children[0];
            triger.addEventListener("click", function(e) {
                _this.toggle();
            });
            var popover = this.$els.popover;
            switch (this.placement) {
              case "top":
                this.position.left = triger.offsetLeft - popover.offsetWidth / 2 + triger.offsetWidth / 2;
                this.position.top = triger.getBoundingClientRect().top - popover.offsetHeight - this.gutter;
                break;

              case "left":
                this.position.left = triger.offsetLeft - popover.offsetWidth - this.gutter;
                this.position.top = triger.getBoundingClientRect().top + triger.offsetHeight / 2 - popover.offsetHeight / 2;
                break;

              case "right":
                this.position.left = triger.offsetLeft + triger.offsetWidth + this.gutter;
                this.position.top = triger.getBoundingClientRect().top + triger.offsetHeight / 2 - popover.offsetHeight / 2;
                break;

              case "bottom":
                this.position.left = triger.offsetLeft - popover.offsetWidth / 2 + triger.offsetWidth / 2;
                this.position.top = triger.getBoundingClientRect().top + triger.offsetHeight + this.gutter;
                break;

              default:
                console.warn("Wrong placement prop");
            }
            popover.style.top = this.position.top + "px";
            popover.style.left = this.position.left + "px";
            popover.style.display = "none";
            this.show = false;
        },
        directives: {
            ClickOutside: _clickOutside2.default
        },
        props: {
            content: String,
            placement: String,
            gutter: {
                type: Number,
                default: 5
            }
        },
        methods: {
            onClickedOutside: function onClickedOutside() {
                if (this.show) {
                    this.show = false;
                    this.$emit("on-hide");
                }
            },
            toggle: function toggle() {
                this.show = !this.show;
                this.$emit("on-" + (this.show === true ? "show" : "hide"));
            }
        },
        data: function data() {
            return {
                position: {
                    top: 0,
                    left: 0
                },
                show: true
            };
        },
        computed: {
            arrowClass: function arrowClass() {
                return {
                    "vux-popover-arrow": true,
                    "vux-popover-arrow-up": this.placement === "bottom",
                    "vux-popover-arrow-right": this.placement === "left",
                    "vux-popover-arrow-left": this.placement === "right",
                    "vux-popover-arrow-down": this.placement === "top"
                };
            }
        }
    };
}, function(module, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.default = {
        acceptStatement: true,
        priority: 700,
        bind: function bind() {
            document.addEventListener("click", this.handler, true);
        },
        update: function update(onClickOutside) {
            if (!this.descriptor.raw) {
                onClickOutside = function onClickOutside() {};
            }
            this.unbind();
            var el = this.el;
            this.handler = function(e) {
                if (el && !el.contains(e.target)) {
                    onClickOutside(e);
                }
            };
            this.bind();
        },
        unbind: function unbind() {
            document.removeEventListener("click", this.handler, true);
        }
    };
}, function(module, exports) {}, function(module, exports) {
    module.exports = " <div v-click-outside=onClickedOutside> <span v-el:trigger> <slot> </slot> </span> <div class=vux-popover :class=\"{\n    'top':placement === 'top',\n    'left':placement === 'left',\n    'right':placement === 'right',\n    'bottom':placement === 'bottom'\n    }\" v-el:popover v-show=show> <div :class=arrowClass></div> <div @click=\"$emit('on-click-content')\"> <slot name=content> <div v-html=content></div> </slot> </div> </div> </div> ";
}, function(module, exports, __webpack_require__) {
    var __vue_script__, __vue_template__;
    var __vue_styles__ = {};
    __webpack_require__(3);
    __vue_script__ = __webpack_require__(1);
    __vue_template__ = __webpack_require__(4);
    module.exports = __vue_script__ || {};
    if (module.exports.__esModule) module.exports = module.exports.default;
    var __vue_options__ = typeof module.exports === "function" ? module.exports.options || (module.exports.options = {}) : module.exports;
    if (__vue_template__) {
        __vue_options__.template = __vue_template__;
    }
    if (!__vue_options__.computed) __vue_options__.computed = {};
    Object.keys(__vue_styles__).forEach(function(key) {
        var module = __vue_styles__[key];
        __vue_options__.computed[key] = function() {
            return module;
        };
    });
} ]);