/*!
 * Vux v0.1.3 (https://vux.li)
 * Licensed under the MIT license
 */
module.exports = function(modules) {
    var installedModules = {};
    function __webpack_require__(moduleId) {
        if (installedModules[moduleId]) return installedModules[moduleId].exports;
        var module = installedModules[moduleId] = {
            exports: {},
            id: moduleId,
            loaded: false
        };
        modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
        module.loaded = true;
        return module.exports;
    }
    __webpack_require__.m = modules;
    __webpack_require__.c = installedModules;
    __webpack_require__.p = "";
    return __webpack_require__(0);
}([ function(module, exports, __webpack_require__) {
    module.exports = __webpack_require__(5);
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    var _zyMedia = __webpack_require__(2);
    var _zyMedia2 = _interopRequireDefault(_zyMedia);
    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }
    console.log(_zyMedia2.default);
    exports.default = {
        props: {
            cover: String,
            video: String
        },
        ready: function ready() {
            this._player = (0, _zyMedia2.default)(this.$el.querySelector("video"));
            console.log(this._player);
        }
    };
}, function(module, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.default = function(selector, options) {
        return new zyMedia.MediaPlayer(selector, options);
    };
    var zyMedia = {};
    zyMedia.config = {
        type: "",
        mediaTitle: "",
        nativeControls: false,
        autoplay: false,
        preload: "none",
        videoWidth: "100%",
        videoHeight: "auto",
        aspectRation: 16 / 9,
        audioWidth: "100%",
        audioHeight: 44,
        autoLoop: false,
        timeFormatType: 1,
        alwaysShowHours: false,
        alwaysShowControls: false,
        hideVideoControlsOnLoad: false,
        enableFullscreen: true,
        pauseOtherPlayers: true,
        duration: 0,
        success: null,
        error: null
    };
    (function(t) {
        var ua = window.navigator.userAgent.toLowerCase();
        var v = document.createElement("video");
        t.isiOS = /iphone|ipod|ipad/i.test(ua) && !window.MSStream;
        t.isAndroid = /android/i.test(ua) && !window.MSStream;
        t.isBustedAndroid = /android 2\.[12]/i.test(ua);
        t.isChromium = /chromium/i.test(ua);
        t.hasTouch = "ontouchstart" in window;
        t.supportsCanPlayType = typeof v.canPlayType !== "undefined";
        t.isVendorBigPlay = /iphone/i.test(ua) && !window.MSStream;
        t.isVendorControls = /baidu/i.test(ua);
        t.isVendorFullscreen = /micromessenger|weibo/i.test(ua);
        t.isVendorAutoplay = /v819mini/i.test(ua) || t.isiOS;
        t.nativeFullscreenPrefix = function() {
            if (v.requestFullScreen) {
                return "";
            } else if (v.webkitRequestFullScreen) {
                return "webkit";
            } else if (v.mozRequestFullScreen) {
                return "moz";
            } else if (v.msRequestFullScreen) {
                return "ms";
            }
            return "-";
        }();
        t.hasOldNativeFullScreen = t.nativeFullscreenPrefix == "-" && v.webkitEnterFullscreen;
        if (t.hasOldNativeFullScreen && /mac os x 10_5/i.test(ua)) {
            t.nativeFullscreenPrefix = "-";
            t.hasOldNativeFullScreen = false;
        }
    })(zyMedia.features = {});
    function _css(el, property) {
        return parseInt(el.style[property] || getComputedStyle(el, null).getPropertyValue(property));
    }
    function _hasClass(el, token) {
        return new RegExp("(\\s|^)" + token + "(\\s|$)").test(el.className);
    }
    function _addClass(el, token) {
        if (el.classList) {
            el.classList.add(token);
        } else if (!_hasClass(el, token)) {
            el.className += "" + token;
        }
    }
    function _removeClass(el, token) {
        if (el.classList) {
            el.classList.remove(token);
        } else if (_hasClass(el, token)) {
            el.className = el.className.replace(new RegExp("(\\s|^)" + token + "(\\s|$)"), " ").replace(/^\s+|\s+$/g, "");
        }
    }
    function timeFormat(time, options) {
        if (!isFinite(time) || time < 0) {
            time = 0;
        }
        var _time = options.alwaysShowHours ? [ 0 ] : [];
        if (Math.floor(time / 3600) % 24) {
            _time.push(Math.floor(time / 3600) % 24);
        }
        _time.push(Math.floor(time / 60) % 60);
        _time.push(Math.floor(time % 60));
        _time = _time.join(":");
        if (options.timeFormatType == 1) {
            _time = _time.replace(/(:|^)([0-9])(?=:|$)/g, "$10$2");
        }
        return _time;
    }
    function isInFullScreenMode() {
        return document.fullscreenElement || document.mozFullScreen || document.webkitIsFullScreen;
    }
    function getTypeFromFileExtension(url) {
        url = url.toLowerCase().split("?")[0];
        var _ext = url.substring(url.lastIndexOf(".") + 1);
        var _av = /mp4|m4v|ogg|ogv|m3u8|webm|webmv|wmv|mpeg|mov/gi.test(_ext) ? "video/" : "audio/";
        switch (_ext) {
          case "mp4":
          case "m4v":
          case "m4a":
            return _av + "mp4";

          case "webm":
          case "webma":
          case "webmv":
            return _av + "webm";

          case "ogg":
          case "oga":
          case "ogv":
            return _av + "ogg";

          case "m3u8":
            return "application/x-mpegurl";

          case "ts":
            return _av + "mp2t";

          default:
            return _av + _ext;
        }
    }
    function getType(url, type) {
        if (url && !type) {
            return getTypeFromFileExtension(url);
        } else {
            if (type && ~type.indexOf(";")) {
                return type.substr(0, type.indexOf(";"));
            } else {
                return type;
            }
        }
    }
    function detectType(media, options, src) {
        var mediaFiles = [];
        var i;
        var n;
        var isCanPlay;
        if (options.type) {
            if (typeof options.type == "string") {
                mediaFiles.push({
                    type: options.type,
                    url: src
                });
            } else {
                for (i = 0; i < options.type.length; i++) {
                    mediaFiles.push({
                        type: options.type[i],
                        url: src
                    });
                }
            }
        } else if (src !== null) {
            mediaFiles.push({
                type: getType(src, media.getAttribute("type")),
                url: src
            });
        } else {
            for (i = 0; i < media.children.length; i++) {
                n = media.children[i];
                if (n.nodeType == 1 && n.tagName.toLowerCase() == "source") {
                    src = n.getAttribute("src");
                    mediaFiles.push({
                        type: getType(src, n.getAttribute("type")),
                        url: src
                    });
                }
            }
        }
        if (zyMedia.features.isBustedAndroid) {
            media.canPlayType = function(type) {
                return /video\/(mp4|m4v)/i.test(type) ? "maybe" : "";
            };
        }
        if (zyMedia.features.isChromium) {
            media.canPlayType = function(type) {
                return /video\/(webm|ogv|ogg)/i.test(type) ? "maybe" : "";
            };
        }
        if (zyMedia.features.supportsCanPlayType) {
            for (i = 0; i < mediaFiles.length; i++) {
                if (mediaFiles[i].type == "video/m3u8" || media.canPlayType(mediaFiles[i].type).replace(/no/, "") !== "" || media.canPlayType(mediaFiles[i].type.replace(/mp3/, "mpeg")).replace(/no/, "") !== "" || media.canPlayType(mediaFiles[i].type.replace(/m4a/, "mp4")).replace(/no/, "") !== "") {
                    isCanPlay = true;
                    break;
                }
            }
        }
        return isCanPlay;
    }
    var zymIndex = 0;
    zyMedia.players = {};
    zyMedia.MediaPlayer = function(media, option) {
        var t = this;
        var i;
        if (media.isInstantiated) {
            return;
        } else {
            media.isInstantiated = true;
        }
        t.media = media;
        var _tagName = t.media.tagName.toLowerCase();
        if (!/audio|video/.test(_tagName)) return;
        t.isVideo = _tagName === "video";
        t.options = {};
        for (i in zyMedia.config) {
            t.options[i] = zyMedia.config[i];
        }
        try {
            for (i in option) {
                t.options[i] = option[i];
            }
            var config = JSON.parse(t.media.getAttribute("data-config"));
            for (i in config) {
                t.options[i] = config[i];
            }
        } catch (exp) {}
        if (t.options.autoplay) {
            t.options.autoplay = !zyMedia.features.isVendorAutoplay;
        }
        if (!t.isVideo) {
            t.options.alwaysShowControls = true;
        }
        if (t.options.nativeControls || zyMedia.features.isVendorControls) {
            t.media.setAttribute("controls", "controls");
        } else {
            var src = t.media.getAttribute("src");
            src = src === "" ? null : src;
            if (detectType(t.media, t.options, src)) {
                t.id = "zym_" + zymIndex++;
                zyMedia.players[t.id] = t;
                t.init();
            } else {
                alert("不支持此" + (t.isVideo ? "视" : "音") + "频");
            }
        }
    };
    zyMedia.MediaPlayer.prototype = {
        isControlsVisible: true,
        isFullScreen: false,
        setPlayerSize: function setPlayerSize(width, height) {
            var t = this;
            var _W = _css(t.container, "width");
            if (width > _W) {
                t.width = _W;
            }
            if (t.enableAutoSize) {
                var nativeWidth = t.media.videoWidth;
                var nativeHeight = t.media.videoHeight;
                if (nativeWidth && nativeHeight) {
                    if (Math.abs(t.options.aspectRation - nativeWidth / nativeHeight) < .1) {
                        t.options.aspectRation = nativeWidth / nativeHeight;
                    }
                }
                t.height = parseInt(_W / t.options.aspectRation);
            }
            t.container.style.width = t.width + "px";
            t.media.style.height = t.container.style.height = t.height + "px";
        },
        showControls: function showControls() {
            var t = this;
            if (t.isControlsVisible) return;
            t.controls.style.bottom = 0;
            if (t.options.mediaTitle) {
                t.title.style.top = 0;
            }
            t.isControlsVisible = true;
        },
        hideControls: function hideControls() {
            var t = this;
            if (!t.isControlsVisible || t.options.alwaysShowControls) return;
            t.controls.style.bottom = "-45px";
            if (t.options.mediaTitle) {
                t.title.style.top = "-35px";
            }
            t.isControlsVisible = false;
        },
        setControlsTimer: function setControlsTimer(timeout) {
            var t = this;
            clearTimeout(t.controlsTimer);
            t.controlsTimer = setTimeout(function() {
                t.hideControls();
            }, timeout);
        },
        updateTimeline: function updateTimeline(e) {
            var t = this;
            var el = e !== undefined ? e.target : t.media;
            var percent = null;
            var _W = _css(t.slider, "width");
            if (el.buffered && el.buffered.length > 0 && el.buffered.end && el.duration) {
                percent = el.buffered.end(el.buffered.length - 1) / el.duration;
            } else if (el.bytesTotal !== undefined && el.bytesTotal > 0 && el.bufferedBytes !== undefined) {
                percent = el.bufferedBytes / el.bytesTotal;
            } else if (e && e.lengthComputable && e.total !== 0) {
                percent = e.loaded / e.total;
            }
            if (percent !== null) {
                percent = Math.min(1, Math.max(0, percent));
                t.loaded.style.width = _W * percent + "px";
                if (t.media.paused) {
                    setTimeout(function() {
                        t.loaded.style.width = _W * percent + "px";
                        t.updateTimeline();
                    }, 300);
                }
            }
            if (t.media.currentTime !== undefined && t.media.duration) {
                var _w = Math.round(_W * t.media.currentTime / t.media.duration);
                t.current.style.width = _w + "px";
                t.handle.style.left = _w - Math.round(_css(t.handle, "width") / 2) + "px";
            }
        },
        updateTime: function updateTime() {
            var t = this;
            t.currentTime.innerHTML = timeFormat(t.media.currentTime, t.options);
            if (t.options.duration > 1 || t.media.duration > 1) {
                t.durationDuration.innerHTML = timeFormat(t.options.duration > 1 ? t.options.duration : t.media.duration, t.options);
            }
        },
        enterFullScreen: function enterFullScreen() {
            var t = this;
            t.normalHeight = _css(t.container, "height");
            t.normalWidth = _css(t.container, "width");
            if (zyMedia.features.nativeFullscreenPrefix != "-") {
                t.container[zyMedia.features.nativeFullscreenPrefix + "RequestFullScreen"]();
            } else if (zyMedia.features.hasOldNativeFullScreen) {
                t.media.webkitEnterFullscreen();
                return;
            }
            _addClass(document.documentElement, "zy_fullscreen");
            t.media.style.width = t.container.style.width = "100%";
            t.media.style.height = t.container.style.height = "100%";
            _addClass(t.fullscreenBtn, "zy_unfullscreen");
            t.isFullScreen = true;
        },
        exitFullScreen: function exitFullScreen() {
            var t = this;
            if (isInFullScreenMode() || t.isFullScreen) {
                if (zyMedia.features.nativeFullscreenPrefix != "-") {
                    document[zyMedia.features.nativeFullscreenPrefix + "CancelFullScreen"]();
                } else if (zyMedia.features.hasOldNativeFullScreen) {
                    document.webkitExitFullscreen();
                }
            }
            _removeClass(document.documentElement, "zy_fullscreen");
            t.media.style.width = t.container.style.width = t.normalWidth + "px";
            t.media.style.height = t.container.style.height = t.normalHeight + "px";
            _removeClass(t.fullscreenBtn, "zy_unfullscreen");
            t.isFullScreen = false;
        },
        buildContainer: function buildContainer() {
            var t = this;
            t.container = t.media.parentNode;
            t.container.style.overflow = "hidden";
            t.container.style.height = (t.isVideo ? _css(t.container, "width") / t.options.aspectRation : t.options.audioHeight) + "px";
            t.container.innerHTML = '<div class="zy_wrap"></div><div class="zy_controls"></div>' + (t.options.mediaTitle ? '<div class="zy_title">' + t.options.mediaTitle + "</div>" : "");
            t.title = t.container.querySelector(".zy_title");
            t.media.setAttribute("preload", t.options.preload);
            t.container.querySelector(".zy_wrap").appendChild(t.media);
            t.controls = t.container.querySelector(".zy_controls");
            if (t.isVideo) {
                t.width = t.options.videoWidth;
                t.height = t.options.videoHeight;
                if (t.width == "100%" && t.height == "auto") {
                    t.enableAutoSize = true;
                }
                t.setPlayerSize(t.width, t.height);
            }
        },
        buildPlaypause: function buildPlaypause() {
            var t = this;
            var play = document.createElement("div");
            play.className = "zy_playpause_btn zy_play";
            t.controls.appendChild(play);
            play.addEventListener("click", function() {
                t.media.isUserClick = true;
                if (t.media.paused) {
                    t.media.play();
                    if (!t.media.paused && !t.options.alwaysShowControls) {
                        t.setControlsTimer(3e3);
                    }
                } else {
                    t.media.pause();
                }
            });
            function togglePlayPause(s) {
                if (t.media.isUserClick || t.options.autoplay) {
                    if ("play" === s) {
                        _removeClass(play, "zy_play");
                        _addClass(play, "zy_pause");
                    } else {
                        _removeClass(play, "zy_pause");
                        _addClass(play, "zy_play");
                    }
                }
            }
            t.media.addEventListener("play", function() {
                togglePlayPause("play");
            });
            t.media.addEventListener("playing", function() {
                togglePlayPause("play");
            });
            t.media.addEventListener("pause", function() {
                togglePlayPause("pse");
            });
            t.media.addEventListener("paused", function() {
                togglePlayPause("pse");
            });
        },
        buildTimeline: function buildTimeline() {
            var t = this;
            var timeline = document.createElement("div");
            timeline.className = "zy_timeline";
            timeline.innerHTML = '<div class="zy_timeline_slider">' + '<div class="zy_timeline_buffering" style="display:none"></div>' + '<div class="zy_timeline_loaded"></div>' + '<div class="zy_timeline_current"></div>' + '<div class="zy_timeline_handle"></div>' + "</div>";
            t.controls.appendChild(timeline);
            t.slider = timeline.children[0];
            t.buffering = t.slider.children[0];
            t.loaded = t.slider.children[1];
            t.current = t.slider.children[2];
            t.handle = t.slider.children[3];
            var isPointerDown = false;
            var _X = t.slider.offsetLeft;
            var _W = _css(t.slider, "width");
            var pointerMove = function pointerMove(e) {
                var _time = 0;
                var x;
                if (e.changedTouches) {
                    x = e.changedTouches[0].pageX;
                } else {
                    x = e.pageX;
                }
                if (t.media.duration) {
                    if (x < _X) {
                        x = _X;
                    } else if (x > _W + _X) {
                        x = _W + _X;
                    }
                    _time = (x - _X) / _W * t.media.duration;
                    if (isPointerDown && _time !== t.media.currentTime) {
                        t.media.currentTime = _time;
                    }
                }
            };
            if (zyMedia.features.hasTouch) {
                t.slider.addEventListener("touchstart", function(e) {
                    isPointerDown = true;
                    pointerMove(e);
                    _X = t.slider.offsetLeft;
                    _W = _css(t.slider, "width");
                    t.slider.addEventListener("touchmove", pointerMove);
                    t.slider.addEventListener("touchend", function(e) {
                        isPointerDown = false;
                        t.slider.removeEventListener("touchmove", pointerMove);
                    });
                });
            } else {
                t.slider.addEventListener("mousedown", function(e) {
                    isPointerDown = true;
                    pointerMove(e);
                    _X = t.slider.offsetLeft;
                    _W = _css(t.slider, "width");
                    t.slider.addEventListener("mousemove", pointerMove);
                    t.slider.addEventListener("mouseup", function(e) {
                        isPointerDown = false;
                        t.slider.addEventListener("mousemove", pointerMove);
                    });
                });
            }
            t.slider.addEventListener("mouseenter", function(e) {
                t.slider.addEventListener("mousemove", pointerMove);
            });
            t.slider.addEventListener("mouseleave", function(e) {
                if (!isPointerDown) {
                    t.slider.removeEventListener("mousemove", pointerMove);
                }
            });
            t.media.addEventListener("timeupdate", function(e) {
                t.updateTimeline(e);
            });
        },
        buildTime: function buildTime() {
            var t = this;
            var time = document.createElement("div");
            time.className = "zy_time";
            time.innerHTML = '<span class="zy_currenttime">' + timeFormat(0, t.options) + "</span>/" + '<span class="zy_duration">' + timeFormat(t.options.duration, t.options) + "</span>";
            t.controls.appendChild(time);
            t.currentTime = time.children[0];
            t.durationDuration = time.children[1];
            t.media.addEventListener("timeupdate", function() {
                t.updateTime();
            });
        },
        buildFullscreen: function buildFullscreen() {
            var t = this;
            if (zyMedia.features.nativeFullscreenPrefix != "-") {
                var func = function func(e) {
                    if (t.isFullScreen) {
                        if (!isInFullScreenMode()) {
                            t.exitFullScreen();
                        }
                    }
                };
                document.addEventListener(zyMedia.features.nativeFullscreenPrefix + "fullscreenchange", func);
            }
            t.fullscreenBtn = document.createElement("div");
            t.fullscreenBtn.className = "zy_fullscreen_btn";
            t.controls.appendChild(t.fullscreenBtn);
            t.fullscreenBtn.addEventListener("click", function() {
                if (zyMedia.features.nativeFullscreenPrefix != "-" && isInFullScreenMode() || t.isFullScreen) {
                    t.exitFullScreen();
                } else {
                    t.enterFullScreen();
                }
            });
        },
        buildDec: function buildDec() {
            var t = this;
            var loading = document.createElement("div");
            loading.className = "dec_loading";
            loading.style.display = "none";
            t.container.appendChild(loading);
            var error = document.createElement("div");
            error.className = "dec_error";
            error.style.display = "none";
            error.innerHTML = "播放异常";
            t.container.appendChild(error);
            var bigPlay = document.createElement("div");
            if (!zyMedia.features.isVendorBigPlay) {
                bigPlay.className = "dec_play";
                t.container.appendChild(bigPlay);
                bigPlay.addEventListener("click", function() {
                    t.media.isUserClick = true;
                    t.media.play();
                    if (!t.media.paused && !t.options.alwaysShowControls) {
                        t.setControlsTimer(3e3);
                    }
                });
            }
            t.media.addEventListener("play", function() {
                if (t.media.isUserClick) {
                    bigPlay.style.display = "none";
                    loading.style.display = "";
                    t.buffering.style.display = "none";
                }
            });
            t.media.addEventListener("playing", function() {
                bigPlay.style.display = "none";
                loading.style.display = "none";
                t.buffering.style.display = "none";
                error.style.display = "none";
            });
            t.media.addEventListener("seeking", function() {
                loading.style.display = "";
                bigPlay.style.display = "none";
                t.buffering.style.display = "";
            });
            t.media.addEventListener("seeked", function() {
                loading.style.display = "none";
                t.buffering.style.display = "none";
            });
            t.media.addEventListener("pause", function() {
                bigPlay.style.display = "";
            });
            t.media.addEventListener("waiting", function() {
                loading.style.display = "";
                bigPlay.style.display = "none";
                t.buffering.style.display = "";
            });
            t.media.addEventListener("error", function(e) {
                loading.style.display = "none";
                bigPlay.style.display = "";
                t.buffering.style.display = "none";
                t.media.pause();
                error.style.display = "";
                if (typeof t.options.error == "function") {
                    t.options.error(e);
                }
            });
        },
        init: function init() {
            var t = this;
            var batch = [ "Container", "Playpause", "Timeline", "Time" ];
            if (t.options.enableFullscreen && !zyMedia.features.isVendorFullscreen && t.isVideo) {
                batch.push("Fullscreen");
            }
            if (t.isVideo) {
                batch.push("Dec");
            }
            for (var i = 0; i < batch.length; i++) {
                try {
                    t["build" + batch[i]]();
                } catch (exp) {}
            }
            if (t.isVideo) {
                if (zyMedia.features.hasTouch) {
                    t.media.addEventListener("click", function() {
                        if (t.isControlsVisible) {
                            t.hideControls();
                        } else {
                            t.showControls();
                            if (!t.media.paused && !t.options.alwaysShowControls) {
                                t.setControlsTimer(3e3);
                            }
                        }
                    });
                } else {
                    t.media.addEventListener("click", function() {
                        if (t.media.paused) {
                            t.media.play();
                        } else {
                            t.media.pause();
                        }
                    });
                    t.container.addEventListener("mouseenter", function() {
                        t.showControls();
                        if (!t.options.alwaysShowControls) {
                            t.setControlsTimer(3e3);
                        }
                    });
                    t.container.addEventListener("mousemove", function() {
                        t.showControls();
                        if (!t.options.alwaysShowControls) {
                            t.setControlsTimer(3e3);
                        }
                    });
                }
                if (t.options.hideVideoControlsOnLoad) {
                    t.hideControls();
                }
                t.media.addEventListener("loadedmetadata", function(e) {
                    if (t.enableAutoSize) {
                        setTimeout(function() {
                            if (!isNaN(t.media.videoHeight)) {
                                t.setPlayerSize();
                            }
                        }, 50);
                    }
                });
            }
            t.media.addEventListener("play", function() {
                var p;
                for (var i in zyMedia.players) {
                    p = zyMedia.players[i];
                    if (p.id != t.id && t.options.pauseOtherPlayers && !p.paused && !p.ended) {
                        try {
                            p.media.pause();
                        } catch (exp) {}
                    }
                }
            });
            window.addEventListener("orientationchange", function() {
                setTimeout(function() {
                    t.setPlayerSize();
                }, 500);
            });
            t.media.addEventListener("ended", function(e) {
                t.media.currentTime = 0;
                if (t.options.autoLoop) {
                    t.media.play();
                } else {
                    if (t.isVideo) {
                        setTimeout(function() {
                            t.container.querySelector(".dec_loading").style.display = "none";
                        }, 20);
                    }
                    t.media.pause();
                }
                t.updateTimeline(e);
            });
            t.media.addEventListener("loadedmetadata", function(e) {
                t.updateTime();
            });
            if (t.options.autoplay) {
                t.media.isUserClick = false;
                t.media.play();
            }
            if (typeof t.options.success == "function") {
                t.options.success(t.media);
            }
        }
    };
}, function(module, exports) {}, function(module, exports) {
    module.exports = ' <div class=zy_media> <video :poster=cover data-config=\'{"mediaTitle": "《疯狂动物城》--腾讯视频"}\'> <source :src=video type=video/mp4> 您的浏览器不支持HTML5视频 </video> </div> ';
}, function(module, exports, __webpack_require__) {
    var __vue_script__, __vue_template__;
    var __vue_styles__ = {};
    __webpack_require__(3);
    __vue_script__ = __webpack_require__(1);
    __vue_template__ = __webpack_require__(4);
    module.exports = __vue_script__ || {};
    if (module.exports.__esModule) module.exports = module.exports.default;
    var __vue_options__ = typeof module.exports === "function" ? module.exports.options || (module.exports.options = {}) : module.exports;
    if (__vue_template__) {
        __vue_options__.template = __vue_template__;
    }
    if (!__vue_options__.computed) __vue_options__.computed = {};
    Object.keys(__vue_styles__).forEach(function(key) {
        var module = __vue_styles__[key];
        __vue_options__.computed[key] = function() {
            return module;
        };
    });
} ]);